#Copyright 2010 Daniel Monedero Tortola faltantornillos at gmail.com

#This file is part of Bright Player 0.4.

#    Bright Player 0.4 is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    Bright Player 0.4 is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
import elementary
import brightCore

def gExit(obj, *args, **kargs):
	elementary.exit()
	brightCore.exit(obj)

def gVolume(widget):
	brightCore.volume(str(int(volumeSlider.value)))

def gMute(widget):
	if brightCore.muted==0 :
		widget.file_set('/usr/share/pixmaps/brightUnmute.png')
		brightCore.unmutedValue=int(volumeSlider.value)
		volumeSlider.value=0
	else :
		widget.file_set('/usr/share/pixmaps/brightMute.png')
		volumeSlider.value=brightCore.unmutedValue
	brightCore.mute()

def gLock(widget):
	brightCore.lock()
	w.fullscreen_set(True)
	#uncomment after upgrade
	#w.callback_focus_out_add(gExit)
	if brightCore.playing == 0:
		hBoxOn.hide()
		vBox.unpack(hBoxOn)
		if brightCore.moodMode == 'True':
			hBoxOff.hide()
			vBox.unpack(hBoxOff)
	else:
		hBoxExitLock.hide()
		vBox.unpack(hBoxExitLock)
		hBoxVol.hide()
		vBox.unpack(hBoxVol)
	hBoxLockUp.show()
	vBox.pack_end(hBoxLockUp)
	hBoxLockDown.show()
	vBox.pack_end(hBoxLockDown)

def gUnlock():
	brightCore.unlock()
	w.fullscreen_set(False)
	#uncomment after upgrade
	#w.callback_focus_out_del(gExit)
	hBoxLockUp.hide()
	vBox.unpack(hBoxLockUp)
	hBoxLockDown.hide()
	vBox.unpack(hBoxLockDown)
	hBoxExitLock.show()
	vBox.pack_end(hBoxExitLock)
	hBoxVol.show()
	vBox.pack_end(hBoxVol)

def gPlay(widget, parameter):
	if brightCore.playing == 0:
		gLock(widget)
	brightCore.play(widget, parameter)

def gFourth(target):
	brightCore.fourth()
	if brightCore.one==1 and brightCore.two==1 and brightCore.three==1 and brightCore.four==1:
		gUnlock()

#window
elementary.init()
w = elementary.Window('Bright Player', elementary.ELM_WIN_BASIC)
w.title_set('Bright Player')
w.autodel_set(True)
#background
bg = elementary.Background(w)
w.resize_object_add(bg)
bg.size_hint_weight_set(1.0, 1.0)
bg.show()
#boxes
vBox = elementary.Box(w)
vBox.size_hint_weight_set(1.0, 1.0)
hBoxExitLock = elementary.Box(w)
hBoxExitLock.size_hint_weight_set(1.0, 1.0)
hBoxExitLock.horizontal_set(True)
hBoxVol = elementary.Box(w)
hBoxVol.size_hint_weight_set(1.0, 1.0)
hBoxVol.horizontal_set(True)
hBoxOn = elementary.Box(w)
hBoxOn.size_hint_weight_set(1.0, 1.0)
hBoxOn.horizontal_set(True)
hBoxOn.show()
if brightCore.moodMode == 'True':
	hBoxOff = elementary.Box(w)
	hBoxOff.size_hint_weight_set(1.0, 1.0)
	hBoxOff.horizontal_set(True)
	hBoxOff.show()
hBoxLockUp = elementary.Box(w)
hBoxLockUp.size_hint_weight_set(1.0, 1.0)
hBoxLockUp.size_hint_align_set(-1.0, -1.0)
hBoxLockUp.horizontal_set(True)
hBoxLockDown = elementary.Box(w)
hBoxLockDown.size_hint_weight_set(1.0, 1.0)
hBoxLockDown.size_hint_align_set(-1.0, -1.0)
hBoxLockDown.horizontal_set(True)
#images
exitImage = elementary.Icon(w)
exitImage.file_set('/usr/share/pixmaps/brightExit.png')
exitImage.scale_set(0, 0)
exitImage.show()
lockImage = elementary.Icon(w)
lockImage.file_set('/usr/share/pixmaps/brightLock.png')
lockImage.scale_set(0, 0)
lockImage.show()
muteImage = elementary.Icon(w)
muteImage.file_set('/usr/share/pixmaps/brightMute.png')
muteImage.scale_set(0, 0)
muteImage.show()
handOnImage = elementary.Icon(w)
handOnImage.file_set('/usr/share/pixmaps/brightHandOn.png')
handOnImage.scale_set(0, 0)
handOnImage.show()
headOnImage = elementary.Icon(w)
headOnImage.file_set('/usr/share/pixmaps/brightHeadOn.png')
headOnImage.scale_set(0, 0)
headOnImage.show()
if brightCore.moodMode == 'True':
	handOffImage = elementary.Icon(w)
	handOffImage.file_set('/usr/share/pixmaps/brightHandOff.png')
	handOffImage.scale_set(0, 0)
	handOffImage.show()
	headOffImage = elementary.Icon(w)
	headOffImage.file_set('/usr/share/pixmaps/brightHeadOff.png')
	headOffImage.scale_set(0, 0)
	headOffImage.show()
#buttons
oneButton = elementary.Button(w)
oneButton.label_set('1')
#expand
oneButton.size_hint_weight_set(1.0, 1.0)
#fill
oneButton.size_hint_align_set(-1.0, -1.0)
oneButton.show()
twoButton = elementary.Button(w)
twoButton.label_set('2')
twoButton.size_hint_weight_set(1.0, 1.0)
twoButton.size_hint_align_set(-1.0, -1.0)
twoButton.show()
threeButton = elementary.Button(w)
threeButton.label_set('3')
threeButton.size_hint_weight_set(1.0, 1.0)
threeButton.size_hint_align_set(-1.0, -1.0)
threeButton.show()
fourButton = elementary.Button(w)
fourButton.label_set('4')
fourButton.size_hint_weight_set(1.0, 1.0)
fourButton.size_hint_align_set(-1.0, -1.0)
fourButton.show()
#volume slider
volumeSlider = elementary.Slider(w)
volumeSlider.unit_format_set('   %.0f')
volumeSlider.indicator_format_set('%.0f')
volumeSlider.min_max_set(0, 127)
volumeSlider.value = int(brightCore.defaultVolume)
volumeSlider.show()
#packs
w.resize_object_add(vBox)
hBoxExitLock.pack_end(lockImage)
hBoxExitLock.pack_end(exitImage)
hBoxOn.pack_end(handOnImage)
hBoxOn.pack_end(headOnImage)
if brightCore.moodMode == 'True':
	hBoxOff.pack_end(handOffImage)
	hBoxOff.pack_end(headOffImage)
hBoxVol.pack_end(volumeSlider)
hBoxVol.pack_end(muteImage)
hBoxLockUp.pack_end(oneButton)
hBoxLockUp.pack_end(fourButton)
hBoxLockDown.pack_end(twoButton)
hBoxLockDown.pack_end(threeButton)
vBox.pack_end(hBoxOn)
if brightCore.moodMode == 'True':
	vBox.pack_end(hBoxOff)
#connections
w.callback_destroy_add(gExit)
exitImage.callback_clicked_add(gExit)
lockImage.callback_clicked_add(gLock)
handOnImage.callback_clicked_add(gPlay, 'handOn')
headOnImage.callback_clicked_add(gPlay, 'headOn')
if brightCore.moodMode == 'True':
	handOffImage.callback_clicked_add(gPlay, 'handOff')
	headOffImage.callback_clicked_add(gPlay, 'headOff')
muteImage.callback_clicked_add(gMute)
volumeSlider.callback_delay_changed_add(gVolume)
oneButton.callback_clicked_add(brightCore.first)
twoButton.callback_clicked_add(brightCore.second)
threeButton.callback_clicked_add(brightCore.third)
fourButton.callback_clicked_add(gFourth)
#shows
vBox.show()
w.show()
#main loop
elementary.run()
elementary.shutdown()