#Copyright 2010 Daniel Monedero Tortola faltantornillos at gmail.com

#This file is part of Bright Player 0.4.

#    Bright Player 0.4 is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    Bright Player 0.4 is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
import gtk
import brightCore

def gExit(widget):
	gtk.main_quit()
	brightCore.exit(widget)

def gVolume(widget):
	brightCore.volume(str(int(widget.get_value())))

def gMute(widget):
	if brightCore.muted==0 :
		widget.set_image(unmuteImage)
		brightCore.unmutedValue=int(volumeScale.get_value())
		volumeScale.set_value(0)
	else :
		widget.set_image(muteImage)
		volumeScale.set_value(brightCore.unmutedValue)
	brightCore.mute()

def gLock(widget):
	brightCore.lock()
	w.fullscreen()
	if brightCore.playing == 0:
		hBoxOn.hide()
		if brightCore.moodMode == 'True':
			hBoxOff.hide()
	else :
		hBoxVol.hide()
		hBoxExitLock.hide()
	lockUpBox.show()
	lockDownBox.show()

def gUnlock():
	brightCore.unlock()
	w.unfullscreen()
	hBoxOn.hide()
	if brightCore.moodMode == 'True':
		hBoxOff.hide()
	lockUpBox.hide()
	lockDownBox.hide()
	hBoxExitLock.show()
	hBoxVol.show()

def gOnFocusOut(widget, event):
	gUnsetFocusOut(widget)
	gExit(widget)

def gUnsetFocusOut(widget):
	global focusOutId
	w.disconnect(focusOutId)

def gSetFocusOut():
	global focusOutId
	focusOutId=w.connect('focus_out_event', gOnFocusOut)

def gPlay(widget, parameter):
	if brightCore.playing == 0:
		gLock(widget)
		gSetFocusOut()
	brightCore.play(widget, parameter)

def gFourth(target):
	brightCore.fourth()
	if brightCore.one==1 and brightCore.two==1 and brightCore.three==1 and brightCore.four==1:
		gUnlock()

#window
w = gtk.Window()
w.set_title('Bright Player')
w.set_icon_from_file('/usr/share/pixmaps/brightPlayer.png')
#boxes
vBox = gtk.VBox()
hBoxExitLock = gtk.HBox()
hBoxVol = gtk.HBox()
hBoxOn = gtk.HBox()
if brightCore.moodMode == 'True':
	hBoxOff = gtk.HBox()
lockUpBox = gtk.HBox()
lockDownBox = gtk.HBox()
#buttons
exitButton = gtk.Button()
lockButton = gtk.Button()
bMute = gtk.Button()
handOnButton = gtk.Button()
headOnButton = gtk.Button()
if brightCore.moodMode == 'True':
	handOffButton = gtk.Button()
	headOffButton = gtk.Button()
oneButton = gtk.Button(label='1')
twoButton = gtk.Button(label='2')
threeButton = gtk.Button(label='3')
fourButton = gtk.Button(label='4')
#volume scale
volumeScale = gtk.HScale()
volumeScale.set_range(0, 127)
volumeScale.set_increments(1, 13)
volumeScale.set_digits(0)
volumeScale.set_value(int(brightCore.defaultVolume))
#images
exitImage = gtk.Image()
lockImage = gtk.Image()
handOnImage = gtk.Image()
headOnImage = gtk.Image()
if brightCore.moodMode == 'True':
	handOffImage = gtk.Image()
	headOffImage = gtk.Image()
unmuteImage = gtk.Image()
muteImage = gtk.Image()
#adds
w.add(vBox)
hBoxExitLock.add(lockButton)
hBoxExitLock.add(exitButton)
hBoxOn.add(handOnButton)
hBoxOn.add(headOnButton)
if brightCore.moodMode == 'True':
	hBoxOff.add(handOffButton)
	hBoxOff.add(headOffButton)
hBoxVol.add(volumeScale)
hBoxVol.pack_end(bMute, False, False, 5)
lockUpBox.add(oneButton)
lockUpBox.add(fourButton)
lockDownBox.add(twoButton)
lockDownBox.add(threeButton)
vBox.add(hBoxExitLock)
vBox.add(hBoxVol)
vBox.add(hBoxOn)
if brightCore.moodMode == 'True':
	vBox.add(hBoxOff)
vBox.add(lockUpBox)
vBox.add(lockDownBox)
#set images
exitImage.set_from_file('/usr/share/pixmaps/brightExit.png')
lockImage.set_from_file('/usr/share/pixmaps/brightLock.png')
handOnImage.set_from_file('/usr/share/pixmaps/brightHandOn.png')
headOnImage.set_from_file('/usr/share/pixmaps/brightHeadOn.png')
if brightCore.moodMode == 'True':
	handOffImage.set_from_file('/usr/share/pixmaps/brightHandOff.png')
	headOffImage.set_from_file('/usr/share/pixmaps/brightHeadOff.png')
unmuteImage.set_from_file('/usr/share/pixmaps/brightUnmute.png')
muteImage.set_from_file('/usr/share/pixmaps/brightMute.png')
lockButton.set_image(lockImage)
handOnButton.set_image(handOnImage)
headOnButton.set_image(headOnImage)
if brightCore.moodMode == 'True':
	handOffButton.set_image(handOffImage)
	headOffButton.set_image(headOffImage)
bMute.set_image(muteImage)
exitButton.set_image(exitImage)
#connections
w.connect('destroy', gExit)
w.connect('destroy_event', gExit)
exitButton.connect('clicked', gExit)
lockButton.connect('clicked', gLock)
handOnButton.connect('clicked', gPlay, 'handOn')
headOnButton.connect('clicked', gPlay, 'headOn')
if brightCore.moodMode == 'True':
	handOffButton.connect('clicked', gPlay, 'handOff')
	headOffButton.connect('clicked', gPlay, 'headOff')
bMute.connect('clicked', gMute)
volumeScale.connect('value-changed', gVolume)
oneButton.connect('clicked', brightCore.first)
twoButton.connect('clicked', brightCore.second)
threeButton.connect('clicked', brightCore.third)
fourButton.connect('clicked', gFourth)
#shows & hides
w.show_all()
hBoxExitLock.hide()
hBoxVol.hide()
lockUpBox.hide()
lockDownBox.hide()
#main loop
gtk.main()